package aQute.speak.gossip;

import java.util.*;

import org.osgi.service.log.*;

import aQute.bnd.annotation.component.*;
import aQute.service.speak.*;

@Component(immediate = true)
public class Gossip implements LogListener {
	Speak speak;
	LogListener listener;

	enum Level {
		INFO, DEBUG, WARNING, ERROR
	};

	Collection<Level> levels = Arrays.asList(Level.INFO,Level.DEBUG,Level.WARNING,Level.ERROR);
	

	@Reference
	protected void setLogReader(LogReaderService lr) {
		lr.addLogListener(this);
	}

	void unsetLogReader(LogReaderService lr) {
		lr.removeLogListener(this);
	}

	public void logged(LogEntry entry) {
		Level l = Level.WARNING;
		switch (entry.getLevel()) {
		case LogService.LOG_DEBUG:
			l = Level.DEBUG;
			break;
		case LogService.LOG_WARNING:
			l = Level.WARNING;
			break;
		case LogService.LOG_ERROR:
			l = Level.ERROR;
			break;
		case LogService.LOG_INFO:
			l = Level.INFO;
			break;
		}
		if (levels.contains(l))
			try {
				speak.say(entry.getMessage());
			} catch (Exception e) {
				// Ignore
			}
	}

	@Reference
	protected void setSpeak(Speak speak) {
		this.speak = speak;
	}
}
